#!/usr/bin/perl

#
# httpdmem.pl
#
# Interface for Apache and MRTG
#
# Copyright 2008 by Steffen Land, info@apachelounge.com .  All rights reserved.
#



$CACHE_FILE = "httpdmem.cache";

sub RetrieveStats(){
  $null = @ENV{COMPUTERNAME} ? "nul" : "/dev/null" ;
  `tasklist  > $CACHE_FILE 2>$null`;

}
sub Validate() {
  if ((scalar(@ARGV) < 2) || ($ARGV[0] eq '')) {
     print "ERR: invalid arguments.\n";
     exit;
  }
}
Validate();
@type = ($ARGV[0],$ARGV[1]);
while (@ARGV) { $x=shift(@ARGV); if ($x =~ /-conf/) {require shift(@ARGV);}}
@result = (0,0);
$complete = 0;
if ( time() - (stat($CACHE_FILE))[9] > (60*2) ){	
	RetrieveStats();
}

open(IN,"< $CACHE_FILE") or die "Could not open cached file";
foreach $line ( <IN> ){

	for($i=0;$i<=1;$i++){
if ($type[$i] eq "httpdmem" && $line =~ /^httpd.exe\D*\d+\D*\d+\D*(\d+).(\d+)/) {$result[$i]=($result[$i]+$1*1000000+$2*1000);next;}
if ($type[$i] eq "systemmem" && $line =~ /$\w*(\d+).(\d+) K/) {$result[$i]=($result[$i]+$1*1000000+$2*1000);next;}
if ($type[$i] eq "systemmem" && $line =~ /$\w*(\d+) K/) {$result[$i]=($result[$i]+$1*1000);next;}
if ($type[$i] eq "null") {$result[$i]="0";}

	}
}
close IN;
print $result[0]."\n";
print $result[1]."\n";
print $uptime."\n";
print $host."\n";

